



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>el-upload源码修改跳坑</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">el-upload源码修改跳坑</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 13:07:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>之前给element-ui提了一个问题，结果没有鸟我，没办法，只能修改源码来满足需求了<br /><br />
(备注：element-ui2依然没有修改，为了迎合产品还是要改源码)</p>
<p>本文讨论的组件属性仅限于<code>list-type='picture-card'</code></p>
<hr>
<p>​	现在的问题是这样的：</p>
<p>​	element-ui中有一个upload组件，可以上传图片或文件。该组件有很丰富的钩子函数与配置，但是没有一个限制上传图片数量(即使是按钮禁用)的方法，于是我就自己封装了一下：</p>
<pre class="prettyprint linenums"><code>&lt;el-upload :disabled='is_max' @s='...' @r='....' ...其余配置&gt;&lt;/el-upload&gt;<br />
</code></pre>
<pre class="prettyprint linenums"><code>export default = {<br />
  props:['num'], // 限制上传数量<br />
  methods:{<br />
    on-success:function(r,f,fl){<br />
    this.is_max = true;<br />
    if(this.num &amp;&amp; this.num === fl.length){<br />
    this.is_max = false;<br />
  }<br />
  this.$emit('s',f,fl);<br />
},<br />
  on-remove:function(f,fl){<br />
    this.is_max = false;<br />
    this.$emit('r',f);<br />
  },<br />
  on-progress:function(){<br />
      this.is_max = true;<br />
  }<br />
}<br />
}<br />
</code></pre>
<p>​	封装添加了一个num参数，限制上传数量，并在上传过程中禁用上传按钮。</p>
<p>​	最初的目的是达到上传数量限制，就禁止上传，但是可以删除图片，删除后解除限制。</p>
<p>​	这个需求在1.3.7版本可以实现，但是在后面的某一次(可见我上一篇文章的结尾)commit中被修改了，删除与上传同时受disabled影响，如果设置disabled='true'，那么这个组件变成了一个纯展示作用，无法删除，无法添加。</p>
<p>​	后来决定暂时用1.3.7版本打包，先出功能。</p>
<hr>
<p>​	原以为事情可以缓一缓，没想到产品对那个上传按钮十分不满，认为如果达到了上限，这个按钮会产生困惑，应该消失。禁用不行，里面弄个叉也不行，必须要消失！</p>
<p>​	好吧，只能来一发硬的，改源码。</p>
<p>​	上传按钮控制的标签如下所示，type为picture,text,picture-card之一。</p>
<pre class="prettyprint linenums"><code>&lt;div class='el-upload el-upload--(type)'&gt;&lt;/div&gt;<br />
</code></pre>
<p>​	当时有两个想法：</p>
<p>1、修改disabled的默认行为，让上传按钮消失，删除按钮不作用</p>
<p>2、引入新的变量，单独控制上传按钮</p>
<p>​	由于不知道源码的内部行为，所以先想着。</p>
<p>​	一开始想法十分简单，找到了目录node_modules\element-ui\packages\upload\src下的upload.vue文件，为了看效果，直接添加了一行代码：</p>
<pre class="prettyprint linenums"><code>// line-163<br />
const data = {<br />
  class: {<br />
    'el-upload': true,<br />
    'abc': true, // 这里是我自己加的<br />
  },<br />
  on: {<br />
    click: handleClick<br />
  }<br />
};<br />
</code></pre>
<p>​	保存-打包-打开网页-F12，发现并没有abc这个类被加上去，查看打包后的JS文件，依然只有一个el-upload类。</p>
<p>​	这就十分尴尬了，于是换了个地方，找到了node_modules\element-ui\lib下的upload.js文件，添加了两行代码：</p>
<pre class="prettyprint linenums"><code>// line-934<br />
var data = {<br />
  class: {<br />
    'el-upload': true,<br />
    'abc': true //同上<br />
  },<br />
  on: {<br />
    click: handleClick<br />
  }<br />
};<br />
// line-1312<br />
var oClass = { 'el-upload': true, 'abc':true};<br />
oClass['el-upload--' + listType] = true;

</code></pre>
<p>​	这里直接修改了打包后的render函数，我想着这次应该稳了，结果打包后一看，还是不行。</p>
<p>​	这就十分尴尬了，只能上网搜搜。一开始找到教程，教你修改哪个文件，然后实现功能，然而跟我之前的步骤一样，不可信。继续搜索，终于找到了一位小哥：<a href="https://segmentfault.com/a/1190000010932321" rel="external nofollow noreferrer">https://segmentfault.com/a/1190000010932321</a></p>
<p>​	懒得看网页的可以找一个安静的文件夹，依次运行以下指令：</p>
<pre class="prettyprint linenums"><code>git clone https://github.com/ElemeFE/element.git<br />
cd element<br />
npm install<br />
</code></pre>
<p>​	此时，element的元身会被下载下来。接下来修改package文件夹中的源码，运行npm run dist指令，该指令会在当前目录生成一个lib文件夹，用这个文件夹替换node_modules中的lib文件夹，然后打包就可以了！</p>
<p>​	事不宜迟，试试！</p>
<p>​	找到了element\packages\upload\src下的upload.vue，再次进行修改：</p>
<pre class="prettyprint linenums"><code>class: {<br />
  'el-upload': true,<br />
    'abc':true,<br />
},<br />
</code></pre>
<p>​	又是熟悉的操作，然而报了2个error，一脸懵逼的看错误信息：</p>
<p>1、Missing space before value for key 'abc'</p>
<p>2、Unexpected trailing comma</p>
<p>​	凭着我过硬的英文功底修正了错误：</p>
<p>1、冒号后面要加空格</p>
<p>2、最后一个属性的逗号要省略</p>
<p>​	修改后再次运行，眼前闪过一片花花绿绿，成了。</p>
<p>​	覆盖了lib文件夹后再次尝试，可以惊喜的看到：</p>
<pre class="prettyprint linenums"><code>&lt;div class='el-upload abc el-upload--picture-card'&gt;&lt;/div&gt;<br />
</code></pre>
<p>​	感觉人生都阳光起来了,接下来是实现目标的时候了。</p>
<hr>
<p>​	简略的看了下upload组件内部，有包含5个组件index、iframe-upload、upload-dragger、upload-list、upload。</p>
<p>​	其中iframe-table是造一个表单，然后表单提交图片信息，略过。</p>
<p>​	upload-dragger是拖拽功能，略过。</p>
<p>​	upload-list实现已图片上传预览，略过。</p>
<p>​	需要关注的只有整合所有组件的index与上传按钮相关的upload组件了。</p>
<p>​	index.vue的整个大概是这样：</p>
<pre class="prettyprint linenums"><code>&lt;div&gt;<br />
  &lt;upload-list&gt;&lt;/upload-list&gt; &lt;!-- 用于展示图片 仅当picture-card类型时在前面 --&gt;<br />
  &lt;uploadComponent&gt; &lt;!-- 上传 内部的DOM会被当成上传按钮 通过FormDataAPI决定调用表单或者ajax --&gt;<br />
  	&lt;upload&gt;&lt;/upload&gt; &lt;!-- drag属性决定是否支持拖拽 --&gt;<br />
  &lt;/uploadComponent&gt;<br />
&lt;/div&gt;<br />
</code></pre>
<p>​	仔细看了一遍内部实现，再回头看一眼之前的2个想法，决定用第二个，修改默认有点麻烦。</p>
<p>​	方式比较简单粗暴，在所有定义diabled的地方加上了一条新语句，比如：</p>
<pre class="prettyprint linenums"><code>// line-94<br />
{<br />
  disabled: Boolean<br />
  Jimmy_input_btn_disabled: Boolean<br />
}<br />
</code></pre>
<p>​	这样就自定义了一个新的数据，第二步，通过这个来阻止上传按钮生成。</p>
<p>​	找来找去，只有一个地方可以控制：</p>
<pre class="prettyprint linenums"><code>// line-254<br />
// 这里是上传按钮的渲染点<br />
const uploadComponent =<br />
      this.Jimmy_input_btn_disabled ? '' : // 我加的<br />
      (typeof FormData !== 'undefined' || this.$isServer)<br />
? &lt;upload {...uploadData}&gt;{trigger}&lt;/upload&gt;<br />
: &lt;iframeUpload {...uploadData}&gt;{trigger}&lt;/iframeUpload&gt;;<br />
</code></pre>
<p>​	加上后，打包测试：</p>
<pre class="prettyprint linenums"><code>&lt;el-upload :Jimmy_input_btn_disabled='is_max' ...其余配置&gt;&lt;/el-upload&gt;<br />
</code></pre>
<p>​	在图片达到上限后，上传按钮惊喜的消失了，舒服！</p>
<p>​	然而，在下一秒，我删除图片的时候，就报了一个错，abort无法执行。</p>
<p>​	顺着报错信息，找到了这里：</p>
<pre class="prettyprint linenums"><code>// 删除时候会调用的函数<br />
handleRemove(file, raw) {<br />
  if (raw) {<br />
    file = this.getFile(raw);<br />
  }<br />
  this.abort(file);<br />
  // ...<br />
},<br />
  //...<br />
abort(file) {<br />
  this.$refs['upload-inner'].abort(file);<br />
},<br />
</code></pre>
<p>​	这个upload-inner呢，在index.vue也有定义：</p>
<pre class="prettyprint linenums"><code>const uploadData = {<br />
  props: {<br />
    // ...一堆参数<br />
  },<br />
  ref: 'upload-inner'<br />
};<br />
</code></pre>
<p>​	再看看上面uploadComponent的定义，我瞬间明白了，这个ref被作为参数传给了上传按钮，删除图片需要执行绑定在该按钮上面的abort函数。问题是，这个按钮被我弄没了，而且由于vue的'析构'，DOM上的事件也没了。</p>
<p>​	结果就是，不可行，粗暴是不对的，两个方案同时否决。</p>
<hr>
<p>​	想了好久，既然不能让DOM消失，那么弄成display:none不就OK了么。</p>
<p>​	两个方案：</p>
<p>1、根据某个条件动态渲染一个自定义的class，该class定义为diaplay:none</p>
<p>2、根据某个条件动态渲染行内样式display:none</p>
<p>​	由于render函数不太记得用法，所以第二个看起来实现有点难度，决定用第一个。当然，这个条件不能是默认的diabled，所以，我的Jimmy_input_btn_disabled又可以出场了。</p>
<p>​	修改的时候遇到了瓶颈，里面的代码居然是JSX，我修改了upload.vue：</p>
<pre class="prettyprint linenums"><code>class: {<br />
  'el-upload': true,<br />
  'abc' : !!this.Jimmy_input_btn_disabled<br />
},<br />
</code></pre>
<p>​	很明显，虽然数据传进来了，但是并没有做到动态渲染，这里只是初始化，所以abc没有出现过，并且在变动的时候，根元素出现了这样的情况：</p>
<pre class="prettyprint linenums"><code>&lt;div Jimmy_input_btn_disabled = 'true'&gt;&lt;/div&gt;<br />
</code></pre>
<p>​	当时真是笑尿我了。</p>
<p>​	一度陷入了僵局，JSX不知道怎么写。如果是vue中的render函数，我还可以写个demo然后模仿。</p>
<p>​	最后我甚至跑去看react的教程，但是人家变动数据用的是setState……</p>
<p>​</p>
<hr>
<p>​	在不断的尝试中的，我是找到了办法，简单的吐血。</p>
<p>​	其实早就发现了，只是陷入了一个误区。</p>
<p>​	首先这个Jimmy_input_btn_disabled需要更改为String类型，作为一个动态类传入：</p>
<pre class="prettyprint linenums"><code>disabled: Boolean,<br />
Jimmy_inputbtn_disabled: String<br />
</code></pre>
<p>​	第二步，在JSX中直接写class：</p>
<pre class="prettyprint linenums"><code>&lt;div {...data} class={Jimmy_input_btn_disabled}&gt;<br />
  ...<br />
&lt;/div&gt;<br />
</code></pre>
<p>​	源码修改完成，打包。</p>
<p>​	html中如下：</p>
<pre class="prettyprint linenums"><code>&lt;div :Jimmy_input_btn_disabled = 'xxx'&gt;&lt;/div&gt;<br />
</code></pre>
<p>​	JS文件如下：</p>
<pre class="prettyprint linenums"><code>new Vue({<br />
  data:{<br />
    xxx:''<br />
  },<br />
  methods:{<br />
    s:function(){<br />
      // 达到上限<br />
      this.xxx = 'xxx';<br />
    },<br />
    r:function(){<br />
      // 解除<br />
      this.xxx = '';<br />
    }<br />
  }<br />
});<br />
</code></pre>
<p>​	CSS很简单，直接设置<code>xxx{display:none}</code>就行了。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/858904/201711/858904-20171102180230935-373313461.png"><br /><br />
<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/858904/201711/858904-20171102180313076-742312202.png"></p>
<p>​	最后测试结果十分成功！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4n5wj9.html">Flapper Bird的学习笔记（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p7ml49.html">AngularJS学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/r931w0r8.html">示例在同一台机器上使用RMAN克隆数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m5v4rq.html">sublime text3 编译less</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g2e278.html">转载 ---&amp;gt&semi; UITableViewCell的分割线</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2ooll9.html">c&plus;&plus;模板库&lpar;简介&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x31g08.html">Android WIFI 启动流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnlrroq.html">js运动 多物体运动含Json 但是里面数值不一样</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xl019.html">ubuntu14&period;04安装opencv3&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1l2159.html">ubuntu sudo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm67w09.html">CART剪枝</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jwvpx8.html">解决ScrollView中的ListView无法显示全</a>
		</li>
						<li><a href="https://www.batexi.com/a/90my5338.html">NYOJ--488--dfs--素数环</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1odmxq.html">MysqL主从复制&lowbar;模式之GTID复制</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpl3169.html">微信小程序之swiper组件高度自适应</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eylkjk9.html">文本分类学习 （七）支持向量机SVM 的前奏 结构风险最小化和VC维度理论</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megwm2q.html">n98-magerun2&period;phar</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j10eyl9.html">django用MySQL数据库链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2j7xy9.html">Python全栈之路----函数进阶----迭代器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25z76wq.html">vue中的axios</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlly3eeq.html">find的用法（完整）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwm42v9.html">Android-AndroidStudio加载工程方式-gradle文件夹</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjl7m49.html">CentOS 7&period;2通过yum安装MairaDB 10&period;1</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd13lv9.html">Python 中的深拷贝和浅拷贝</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2xypy9.html">读取ViewBag匿名类</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w5420q.html">使用更改跟踪&lpar;ChangeTracking&rpar;来实现数据类型变更</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjw7m59.html">转MySQL遇到的语法差异及解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2x6yo9.html">&lbrack;学习笔记&rsqb;普通平衡树Splay</a>
			</li>
						<li><a href="https://www.batexi.com/a/90roz6m9.html">Tomcat在Linux下的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2gg7pq.html">纯css实现打字效果</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
